
' Snow Bird Hunt
' Pirate Kart 2012
' Kristopher Windsor

#include once "fbgfx.bi"

const sx = 720, sy = 480
const b_max = 1024

type bammo
  as integer tx, ty, to_impact
  as double x, y
end type

dim shared as integer b_total, ow(1 to 4), mx, my, mb, pmb, score
dim shared as bammo b(1 to b_max)
dim shared as fb.image ptr background, mask

screenres sx, sy, 32
WindowTitle("Snow Bird Hunt")

background = imagecreate(sx, sy)
mask = imagecreate(sx, sy)
bload("background.bmp", background)
bload("mask.bmp", mask)

do
  pmb = mb
  getmouse(mx, my,, mb)
  
  if mb > 0 and pmb = 0 and b_total < b_max then
    b_total += 1
    with b(b_total)
      .tx = mx
      .ty = my
      .to_impact = 20
      .x = sx \ 2 + (mx - sx \ 2) \ 2
      .y = sy + 20
    end with
  end if
  
  for i as integer = 1 to b_total
    with b(i)
      .x += (.tx - .x) / 6
      .y += (.ty - .y) / 6
      .to_impact -= 1
      if .to_impact <= 0 then
        if point(.tx, .ty, mask) = &HFF000000 then
          score += 1
          WindowTitle("Snow Bird Hunt - " & score)
          if .tx < 260 then
            ow(1) = 30
          elseif .tx < 390 then
            ow(2) = 30
          elseif .tx < 500 then
            ow(3) = 30
          else
            ow(4) = 30
          endif
        end if
        b_total -= 1
        for j as integer = i to b_total
          b(j) = b(j + 1)
        next j
        exit for
      end if
    end with
  next i
  
  for i as integer = 1 to 4
    ow(i) -= 1
  next i
  
  screenlock()
  put (0, 0), background, pset
  if ow(1) > 0 then draw string (190, 112), "OW!!", &HFF000000
  if ow(2) > 0 then draw string (386, 177), "OW!!", &HFF000000
  if ow(3) > 0 then draw string (474, 210), "OW!!", &HFF000000
  if ow(4) > 0 then draw string (600, 254), "OW!!", &HFF000000
  for i as integer = 1 to b_total
    with b(i)
      circle (.x, .y), 8 + .to_impact / 2, &HFFFF0000,,, 1, F
    end with
  next i
  screenunlock()
  
  sleep(18, 1)
loop until inkey() = chr(27)

